Index: contrib/ntp/sntp/tests/packetProcessing.c
===================================================================
--- contrib/ntp/sntp/tests/packetProcessing.c	(revision 330566)
+++ contrib/ntp/sntp/tests/packetProcessing.c	(revision 330631)
@@ -5,7 +5,10 @@
 #include "ntp_stdlib.h"
 #include "unity.h"
 
+#define CMAC		"AES128CMAC"
+#define CMAC_LENGTH	16
 
+
 const char * Version = "stub unit test Version string";
 
 /* Hacks into the key database. */
@@ -35,6 +38,7 @@
 void test_CorrectUnauthenticatedPacket(void);
 void test_CorrectAuthenticatedPacketMD5(void);
 void test_CorrectAuthenticatedPacketSHA1(void);
+void test_CorrectAuthenticatedPacketCMAC(void);
 
 /* [Bug 2998] There are some issues whith the definition of 'struct pkt'
  * when AUTOKEY is undefined -- the formal struct is too small to hold
@@ -76,7 +80,7 @@
 	key_ptr->next = NULL;
 	key_ptr->key_id = key_id;
 	key_ptr->key_len = key_len;
-	memcpy(key_ptr->type, "MD5", 3);
+	memcpy(key_ptr->typen, type, strlen(type) + 1);
 
 	TEST_ASSERT_TRUE(key_len < sizeof(key_ptr->key_seq));
 
@@ -231,7 +235,7 @@
 
 	testpkt.p.exten[0] = htonl(50);
 	int mac_len = make_mac(&testpkt.p, pkt_len,
-			       MAX_MD5_LEN, key_ptr,
+			       MAX_MD5_LEN - KEY_MAC_LEN, key_ptr,
 			       &testpkt.p.exten[1]);
 
 	pkt_len += 4 + mac_len;
@@ -259,9 +263,9 @@
 
 	testpkt.p.exten[0] = htonl(50);
 	int mac_len = make_mac(&testpkt.p, pkt_len,
-			       MAX_MD5_LEN, key_ptr,
+			       MAX_MD5_LEN - KEY_MAC_LEN, key_ptr,
 			       &testpkt.p.exten[1]);
-	pkt_len += 4 + mac_len;
+	pkt_len += KEY_MAC_LEN + mac_len;
 
 	TEST_ASSERT_EQUAL(SERVER_AUTH_FAIL,
 			  process_pkt(&testpkt.p, &testsock, pkt_len,
@@ -424,10 +428,10 @@
 	/* Prepare the packet. */
 	testpkt.p.exten[0] = htonl(10);
 	int mac_len = make_mac(&testpkt.p, pkt_len,
-			       MAX_MD5_LEN, key_ptr,
+			       MAX_MD5_LEN - KEY_MAC_LEN, key_ptr,
 			       &testpkt.p.exten[1]);
 
-	pkt_len += 4 + mac_len;
+	pkt_len += KEY_MAC_LEN + mac_len;
 
 	TEST_ASSERT_EQUAL(pkt_len,
 			  process_pkt(&testpkt.p, &testsock, pkt_len,
@@ -446,6 +450,28 @@
 	/* Prepare the packet. */
 	testpkt.p.exten[0] = htonl(20);
 	int mac_len = make_mac(&testpkt.p, pkt_len,
+			       MAX_MDG_LEN, key_ptr,
+			       &testpkt.p.exten[1]);
+
+	pkt_len += KEY_MAC_LEN + mac_len;
+
+	TEST_ASSERT_EQUAL(pkt_len,
+			  process_pkt(&testpkt.p, &testsock, pkt_len,
+				      MODE_SERVER, &testspkt.p, "UnitTest"));
+}
+
+
+void
+test_CorrectAuthenticatedPacketCMAC(void)
+{
+	PrepareAuthenticationTest(30, CMAC_LENGTH, CMAC, "abcdefghijklmnop");
+	TEST_ASSERT_TRUE(ENABLED_OPT(AUTHENTICATION));
+
+	int pkt_len = LEN_PKT_NOMAC;
+
+	/* Prepare the packet. */
+	testpkt.p.exten[0] = htonl(30);
+	int mac_len = make_mac(&testpkt.p, pkt_len,
 			       MAX_MAC_LEN, key_ptr,
 			       &testpkt.p.exten[1]);
 
@@ -455,3 +481,4 @@
 			  process_pkt(&testpkt.p, &testsock, pkt_len,
 				      MODE_SERVER, &testspkt.p, "UnitTest"));
 }
+
Index: contrib/ntp/sntp/tests/run-kodFile.c
===================================================================
--- contrib/ntp/sntp/tests/run-kodFile.c	(revision 330566)
+++ contrib/ntp/sntp/tests/run-kodFile.c	(revision 330631)
@@ -39,6 +39,13 @@
 extern void test_WriteFileWithMultipleEntries(void);
 
 
+//=======Suite Setup=====
+static void suite_setup(void)
+{
+extern int change_logfile(const char*, int);
+change_logfile("stderr", 0);
+}
+
 //=======Test Reset Option=====
 void resetTest(void);
 void resetTest(void)
@@ -54,6 +61,7 @@
 int main(int argc, char *argv[])
 {
   progname = argv[0];
+  suite_setup();
   UnityBegin("kodFile.c");
   RUN_TEST(test_ReadEmptyFile, 19);
   RUN_TEST(test_ReadCorrectFile, 20);
Index: contrib/ntp/scripts/summary.1summaryman
===================================================================
--- contrib/ntp/scripts/summary.1summaryman	(revision 330566)
+++ contrib/ntp/scripts/summary.1summaryman	(revision 330631)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH summary 1summaryman "21 Mar 2017" "ntp (4.2.8p10)" "User Commands"
+.TH summary 1summaryman "27 Feb 2018" "ntp (4.2.8p11)" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-41aOWo/ag-h2aWVo)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-AMaaJG/ag-NMaiIG)
 .\"
-.\" It has been AutoGen-ed March 21, 2017 at 10:40:48 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed February 27, 2018 at 04:56:06 PM by AutoGen 5.18.5
 .\" From the definitions summary-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
Index: contrib/ntp/scripts/plot_summary.mdoc.in
===================================================================
--- contrib/ntp/scripts/plot_summary.mdoc.in	(revision 330566)
+++ contrib/ntp/scripts/plot_summary.mdoc.in	(revision 330631)
@@ -1,9 +1,9 @@
-.Dd March 21 2017
+.Dd February 27 2018
 .Dt PLOT_SUMMARY 1plot_summarymdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (plot_summary-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  March 21, 2017 at 10:40:44 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  February 27, 2018 at 04:56:02 PM by AutoGen 5.18.5
 .\"  From the definitions    plot_summary-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: contrib/ntp/scripts/summary.mdoc.in
===================================================================
--- contrib/ntp/scripts/summary.mdoc.in	(revision 330566)
+++ contrib/ntp/scripts/summary.mdoc.in	(revision 330631)
@@ -1,9 +1,9 @@
-.Dd March 21 2017
+.Dd February 27 2018
 .Dt SUMMARY 1summarymdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (summary-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  March 21, 2017 at 10:40:49 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  February 27, 2018 at 04:56:08 PM by AutoGen 5.18.5
 .\"  From the definitions    summary-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: contrib/ntp/scripts/update-leap/update-leap.1update-leapman
===================================================================
--- contrib/ntp/scripts/update-leap/update-leap.1update-leapman	(revision 330566)
+++ contrib/ntp/scripts/update-leap/update-leap.1update-leapman	(revision 330631)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH update-leap 1update-leapman "21 Mar 2017" "ntp (4.2.8p10)" "User Commands"
+.TH update-leap 1update-leapman "27 Feb 2018" "ntp (4.2.8p11)" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-6XaW6m/ag-hYa45m)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-cKaOWT/ag-pKaWVT)
 .\"
-.\" It has been AutoGen-ed March 21, 2017 at 10:40:27 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed February 27, 2018 at 10:50:15 AM by AutoGen 5.18.5
 .\" From the definitions update-leap-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
Index: contrib/ntp/scripts/update-leap/update-leap.man.in
===================================================================
--- contrib/ntp/scripts/update-leap/update-leap.man.in	(revision 330566)
+++ contrib/ntp/scripts/update-leap/update-leap.man.in	(revision 330631)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH update-leap 1update-leapman "21 Mar 2017" "ntp (4.2.8p10)" "User Commands"
+.TH update-leap 1update-leapman "27 Feb 2018" "ntp (4.2.8p11)" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-6XaW6m/ag-hYa45m)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-cKaOWT/ag-pKaWVT)
 .\"
-.\" It has been AutoGen-ed March 21, 2017 at 10:40:27 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed February 27, 2018 at 10:50:15 AM by AutoGen 5.18.5
 .\" From the definitions update-leap-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
Index: contrib/ntp/sntp/include/version.def
===================================================================
--- contrib/ntp/sntp/include/version.def	(revision 330566)
+++ contrib/ntp/sntp/include/version.def	(revision 330631)
@@ -1 +1 @@
-version = '4.2.8p10';
+version = '4.2.8p11';
Index: contrib/ntp/sntp/m4/ntp_harden.m4
===================================================================
--- contrib/ntp/sntp/m4/ntp_harden.m4	(revision 330566)
+++ contrib/ntp/sntp/m4/ntp_harden.m4	(revision 330631)
@@ -10,24 +10,24 @@
 AC_MSG_CHECKING([for compile/link hardening flags])
 
 AC_ARG_WITH(
-    [locfile],
+    [hardenfile],
     [AS_HELP_STRING(
-	[--with-locfile=XXX],
-	[os-specific or "legacy"]
+	[--with-hardenfile=XXX],
+	[os-specific or "/dev/null"]
     )],
     [],
-    [with_locfile=no]
+    [with_hardenfile=no]
 )
 
 (									\
     SENTINEL_DIR="$PWD" &&						\
     cd $srcdir/$1 &&							\
-    case "$with_locfile" in						\
+    case "$with_hardenfile" in						\
      yes|no|'')								\
 	scripts/genHardFlags -d "$SENTINEL_DIR"				\
 	;;								\
      *)									\
-	scripts/genHardFlags -d "$SENTINEL_DIR" -f "$with_locfile"	\
+	scripts/genHardFlags -d "$SENTINEL_DIR" -f "$with_hardenfile"	\
 	;;								\
     esac								\
 ) > genHardFlags.i 2> genHardFlags.err
Index: contrib/ntp/sntp/main.c
===================================================================
--- contrib/ntp/sntp/main.c	(revision 330566)
+++ contrib/ntp/sntp/main.c	(revision 330631)
@@ -207,9 +207,8 @@
 	*/
 	kod_init_kod_db(OPT_ARG(KOD), FALSE);
 
-	// HMS: Should we use arg-defalt for this too?
-	if (HAVE_OPT(KEYFILE))
-		auth_init(OPT_ARG(KEYFILE), &keys);
+	/* HMS: Check and see what happens if KEYFILE doesn't exist */
+	auth_init(OPT_ARG(KEYFILE), &keys);
 
 	/*
 	** Considering employing a variable that prevents functions of doing
@@ -379,7 +378,6 @@
 {
 	struct addrinfo	hints;	/* Local copy is OK */
 	struct dns_ctx *ctx;
-	long		l;
 	char *		name_copy;
 	size_t		name_sz;
 	size_t		octets;
@@ -405,15 +403,19 @@
 	ctx->name = name_copy;			// point to it...
 	ctx->flags = flags;
 	ctx->timeout = response_tv;
+	ctx->key = NULL;
 
 	/* The following should arguably be passed in... */
-	if (ENABLED_OPT(AUTHENTICATION) &&
-	    atoint(OPT_ARG(AUTHENTICATION), &l)) {
-		ctx->key_id = l;
+	if (ENABLED_OPT(AUTHENTICATION)) {
+		ctx->key_id = OPT_VALUE_AUTHENTICATION;
 		get_key(ctx->key_id, &ctx->key);
+		if (NULL == ctx->key) {
+			fprintf(stderr, "%s: Authentication with keyID %d requested, but no matching keyID found in <%s>!\n",
+				progname, ctx->key_id, OPT_ARG(KEYFILE));
+			exit(1);
+		}
 	} else {
 		ctx->key_id = -1;
-		ctx->key = NULL;
 	}
 
 	++n_pending_dns;
@@ -1132,13 +1134,21 @@
 	x_pkt->ppoll = 8;
 	/* FIXME! Modus broadcast + adr. check -> bdr. pkt */
 	set_li_vn_mode(x_pkt, LEAP_NOTINSYNC, ntpver, 3);
+	if (debug > 0) {
+		printf("generate_pkt: key_id %d, key pointer %p\n", key_id, pkt_key);
+	}
 	if (pkt_key != NULL) {
 		x_pkt->exten[0] = htonl(key_id);
-		mac_size = 20; /* max room for MAC */
-		mac_size = make_mac(x_pkt, pkt_len, mac_size,
+		mac_size = make_mac(x_pkt, pkt_len, MAX_MDG_LEN,
 				    pkt_key, (char *)&x_pkt->exten[1]);
 		if (mac_size > 0)
-			pkt_len += mac_size + 4;
+			pkt_len += mac_size + KEY_MAC_LEN;
+#ifdef DEBUG
+		if (debug > 0) {
+			printf("generate_pkt: mac_size is %d\n", mac_size);
+		}
+#endif
+
 	}
 	return pkt_len;
 }
Index: contrib/ntp/sntp/sntp-opts.h
===================================================================
--- contrib/ntp/sntp/sntp-opts.h	(revision 330566)
+++ contrib/ntp/sntp/sntp-opts.h	(revision 330631)
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (sntp-opts.h)
  *
- *  It has been AutoGen-ed  March 21, 2017 at 10:36:28 AM by AutoGen 5.18.5
+ *  It has been AutoGen-ed  February 27, 2018 at 10:25:31 AM by AutoGen 5.18.5
  *  From the definitions    sntp-opts.def
  *  and the template file   options
  *
@@ -91,9 +91,9 @@
 /** count of all options for sntp */
 #define OPTION_CT    23
 /** sntp version */
-#define SNTP_VERSION       "4.2.8p10"
+#define SNTP_VERSION       "4.2.8p11"
 /** Full sntp version text */
-#define SNTP_FULL_VERSION  "sntp 4.2.8p10"
+#define SNTP_FULL_VERSION  "sntp 4.2.8p11"
 
 /**
  *  Interface defines for all options.  Replace "n" with the UPPER_CASED
Index: contrib/ntp/sntp/sntp.man.in
===================================================================
--- contrib/ntp/sntp/sntp.man.in	(revision 330566)
+++ contrib/ntp/sntp/sntp.man.in	(revision 330631)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH sntp @SNTP_MS@ "21 Mar 2017" "4.2.8p10" "User Commands"
+.TH sntp @SNTP_MS@ "27 Feb 2018" "4.2.8p11" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-aQaqbX/ag-nQaiaX)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-eaayfN/ag-qaaqeN)
 .\"
-.\" It has been AutoGen-ed March 21, 2017 at 10:36:45 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed February 27, 2018 at 05:13:07 PM by AutoGen 5.18.5
 .\" From the definitions sntp-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
@@ -162,6 +162,11 @@
 .TP
 .NOP \f\*[B-Font]\-k\f[] \f\*[I-Font]file\-name\f[], \f\*[B-Font]\-\-keyfile\f[]=\f\*[I-Font]file\-name\f[]
 Look in this file for the key specified with \fB-a\fP.
+The default
+\f\*[I-Font]file\-name\f[]
+for this option is:
+.ti +4
+ /etc/ntp.keys
 .sp
 This option specifies the keyfile.
 \fBsntp\fP will search for the key specified with \fB-a\fP
Index: contrib/ntp/sntp/tests/crypto.c
===================================================================
--- contrib/ntp/sntp/tests/crypto.c	(revision 330566)
+++ contrib/ntp/sntp/tests/crypto.c	(revision 330631)
@@ -5,18 +5,26 @@
 #include "sntptest.h"
 #include "crypto.h"
 
+#define CMAC "AES128CMAC"
+
 #define MD5_LENGTH 16
 #define SHA1_LENGTH 20
+#define CMAC_LENGTH 16
 
 
 void test_MakeMd5Mac(void);
 void test_MakeSHA1Mac(void);
+void test_MakeCMac(void);
 void test_VerifyCorrectMD5(void);
 void test_VerifySHA1(void);
+void test_VerifyCMAC(void);
 void test_VerifyFailure(void);
 void test_PacketSizeNotMultipleOfFourBytes(void);
 
+void VerifyLocalCMAC(struct key *cmac);
+void VerifyOpenSSLCMAC(struct key *cmac);
 
+
 void
 test_MakeMd5Mac(void)
 {
@@ -31,8 +39,9 @@
 	md5.key_id = 10;
 	md5.key_len = 6;
 	memcpy(&md5.key_seq, "md5seq", md5.key_len);
-	memcpy(&md5.type, "MD5", 4);
-
+	strlcpy(md5.typen, "MD5", sizeof(md5.typen));
+	md5.typei = keytype_from_text(md5.typen, NULL);
+	
 	TEST_ASSERT_EQUAL(MD5_LENGTH,
 			  make_mac(PKT_DATA, PKT_LEN, MD5_LENGTH, &md5, actual));
 
@@ -57,7 +66,8 @@
 	sha1.key_id = 20;
 	sha1.key_len = 7;
 	memcpy(&sha1.key_seq, "sha1seq", sha1.key_len);
-	memcpy(&sha1.type, "SHA1", 5);
+	strlcpy(sha1.typen, "SHA1", sizeof(sha1.typen));
+	sha1.typei = keytype_from_text(sha1.typen, NULL);
 
 	TEST_ASSERT_EQUAL(SHA1_LENGTH,
 			  make_mac(PKT_DATA, PKT_LEN, SHA1_LENGTH, &sha1, actual));
@@ -73,6 +83,38 @@
 
 
 void
+test_MakeCMac(void)
+{
+#ifdef OPENSSL
+
+	const char* PKT_DATA = "abcdefgh0123";
+	const int PKT_LEN = strlen(PKT_DATA);
+	const char* EXPECTED_DIGEST =
+		"\xdd\x35\xd5\xf5\x14\x23\xd9\xd6"
+		"\x38\x5d\x29\x80\xfe\x51\xb9\x6b";
+	char actual[CMAC_LENGTH];
+
+	struct key cmac;
+	cmac.next = NULL;
+	cmac.key_id = 30;
+	cmac.key_len = CMAC_LENGTH;
+	memcpy(&cmac.key_seq, "aes-128-cmac-seq", cmac.key_len);
+	memcpy(&cmac.typen, CMAC, strlen(CMAC) + 1);
+
+	TEST_ASSERT_EQUAL(CMAC_LENGTH,
+		    make_mac(PKT_DATA, PKT_LEN, CMAC_LENGTH, &cmac, actual));
+
+	TEST_ASSERT_EQUAL_MEMORY(EXPECTED_DIGEST, actual, CMAC_LENGTH);
+	
+#else
+	
+	TEST_IGNORE_MESSAGE("OpenSSL not found, skipping...");
+	
+#endif	/* OPENSSL */
+}
+
+
+void
 test_VerifyCorrectMD5(void)
 {
 	const char* PKT_DATA =
@@ -87,7 +129,8 @@
 	md5.key_id = 0;
 	md5.key_len = 6;
 	memcpy(&md5.key_seq, "md5key", md5.key_len);
-	memcpy(&md5.type, "MD5", 4);
+	strlcpy(md5.typen, "MD5", sizeof(md5.typen));
+	md5.typei = keytype_from_text(md5.typen, NULL);
 
 	TEST_ASSERT_TRUE(auth_md5(PKT_DATA, PKT_LEN, MD5_LENGTH, &md5));
 }
@@ -110,7 +153,8 @@
 	sha1.key_id = 0;
 	sha1.key_len = 7;
 	memcpy(&sha1.key_seq, "sha1key", sha1.key_len);
-	memcpy(&sha1.type, "SHA1", 5);
+	strlcpy(sha1.typen, "SHA1", sizeof(sha1.typen));	
+	sha1.typei = keytype_from_text(sha1.typen, NULL);
 
 	TEST_ASSERT_TRUE(auth_md5(PKT_DATA, PKT_LEN, SHA1_LENGTH, &sha1));
 	
@@ -121,7 +165,61 @@
 #endif	/* OPENSSL */
 }
 
+
 void
+test_VerifyCMAC(void)
+{
+	const char* PKT_DATA =
+	    "sometestdata"				/* Data */
+	    "\0\0\0\0"					/* Key-ID (unused) */
+	    "\x4e\x0c\xf0\xe2\xc7\x8e\xbb\xbf"		/* MAC */
+	    "\x79\xfc\x87\xc7\x8b\xb7\x4a\x0b";
+	const int PKT_LEN = 12;
+	struct key cmac;
+
+	cmac.next = NULL;
+	cmac.key_id = 0;
+	cmac.key_len = CMAC_LENGTH;
+	memcpy(&cmac.key_seq, "aes-128-cmac-key", cmac.key_len);
+	memcpy(&cmac.typen, CMAC, strlen(CMAC) + 1);
+
+	VerifyOpenSSLCMAC(&cmac);
+	VerifyLocalCMAC(&cmac);
+}
+
+
+void
+VerifyOpenSSLCMAC(struct key *cmac)
+{
+#ifdef OPENSSL
+
+	/* XXX: HMS: auth_md5 must be renamed/incorrect. */
+	// TEST_ASSERT_TRUE(auth_md5(PKT_DATA, PKT_LEN, CMAC_LENGTH, cmac));
+	TEST_IGNORE_MESSAGE("VerifyOpenSSLCMAC needs to be implemented, skipping...");
+
+#else
+	
+	TEST_IGNORE_MESSAGE("OpenSSL not found, skipping...");
+	
+#endif	/* OPENSSL */
+	return;
+}
+
+
+void
+VerifyLocalCMAC(struct key *cmac)
+{
+
+	/* XXX: HMS: auth_md5 must be renamed/incorrect. */
+	// TEST_ASSERT_TRUE(auth_md5(PKT_DATA, PKT_LEN, CMAC_LENGTH, cmac));
+
+	TEST_IGNORE_MESSAGE("Hook in the local AES-128-CMAC check!");
+
+	return;
+}
+
+
+void
 test_VerifyFailure(void)
 {
 	/* We use a copy of the MD5 verification code, but modify the
@@ -139,7 +237,8 @@
 	md5.key_id = 0;
 	md5.key_len = 6;
 	memcpy(&md5.key_seq, "md5key", md5.key_len);
-	memcpy(&md5.type, "MD5", 4);
+	strlcpy(md5.typen, "MD5", sizeof(md5.typen));
+	md5.typei = keytype_from_text(md5.typen, NULL);
 
 	TEST_ASSERT_FALSE(auth_md5(PKT_DATA, PKT_LEN, MD5_LENGTH, &md5));
 }
@@ -157,7 +256,8 @@
 	md5.key_id = 10;
 	md5.key_len = 6;
 	memcpy(&md5.key_seq, "md5seq", md5.key_len);
-	memcpy(&md5.type, "MD5", 4);
+	strlcpy(md5.typen, "MD5", sizeof(md5.typen));
+	md5.typei = keytype_from_text(md5.typen, NULL);
 
 	TEST_ASSERT_EQUAL(0, make_mac(PKT_DATA, PKT_LEN, MD5_LENGTH, &md5, actual));
 }
Index: contrib/ntp/sntp/tests/run-crypto.c
===================================================================
--- contrib/ntp/sntp/tests/run-crypto.c	(revision 330566)
+++ contrib/ntp/sntp/tests/run-crypto.c	(revision 330631)
@@ -32,12 +32,21 @@
 extern void tearDown(void);
 extern void test_MakeMd5Mac(void);
 extern void test_MakeSHA1Mac(void);
+extern void test_MakeCMac(void);
 extern void test_VerifyCorrectMD5(void);
 extern void test_VerifySHA1(void);
+extern void test_VerifyCMAC(void);
 extern void test_VerifyFailure(void);
 extern void test_PacketSizeNotMultipleOfFourBytes(void);
 
 
+//=======Suite Setup=====
+static void suite_setup(void)
+{
+extern int change_logfile(const char*, int);
+change_logfile("stderr", 0);
+}
+
 //=======Test Reset Option=====
 void resetTest(void);
 void resetTest(void)
@@ -53,13 +62,16 @@
 int main(int argc, char *argv[])
 {
   progname = argv[0];
+  suite_setup();
   UnityBegin("crypto.c");
-  RUN_TEST(test_MakeMd5Mac, 12);
-  RUN_TEST(test_MakeSHA1Mac, 13);
-  RUN_TEST(test_VerifyCorrectMD5, 14);
-  RUN_TEST(test_VerifySHA1, 15);
-  RUN_TEST(test_VerifyFailure, 16);
-  RUN_TEST(test_PacketSizeNotMultipleOfFourBytes, 17);
+  RUN_TEST(test_MakeMd5Mac, 15);
+  RUN_TEST(test_MakeSHA1Mac, 16);
+  RUN_TEST(test_MakeCMac, 17);
+  RUN_TEST(test_VerifyCorrectMD5, 18);
+  RUN_TEST(test_VerifySHA1, 19);
+  RUN_TEST(test_VerifyCMAC, 20);
+  RUN_TEST(test_VerifyFailure, 21);
+  RUN_TEST(test_PacketSizeNotMultipleOfFourBytes, 22);
 
   return (UnityEnd());
 }
Index: contrib/ntp/sntp/tests/run-networking.c
===================================================================
--- contrib/ntp/sntp/tests/run-networking.c	(revision 330566)
+++ contrib/ntp/sntp/tests/run-networking.c	(revision 330631)
@@ -31,6 +31,13 @@
 extern void tearDown(void);
 
 
+//=======Suite Setup=====
+static void suite_setup(void)
+{
+extern int change_logfile(const char*, int);
+change_logfile("stderr", 0);
+}
+
 //=======Test Reset Option=====
 void resetTest(void);
 void resetTest(void)
@@ -46,6 +53,7 @@
 int main(int argc, char *argv[])
 {
   progname = argv[0];
+  suite_setup();
   UnityBegin("networking.c");
 
   return (UnityEnd());
Index: contrib/ntp/sntp/tests/run-t-log.c
===================================================================
--- contrib/ntp/sntp/tests/run-t-log.c	(revision 330566)
+++ contrib/ntp/sntp/tests/run-t-log.c	(revision 330631)
@@ -33,6 +33,13 @@
 extern void testWriteInCustomLogfile(void);
 
 
+//=======Suite Setup=====
+static void suite_setup(void)
+{
+extern int change_logfile(const char*, int);
+change_logfile("stderr", 0);
+}
+
 //=======Test Reset Option=====
 void resetTest(void);
 void resetTest(void)
@@ -48,6 +55,7 @@
 int main(int argc, char *argv[])
 {
   progname = argv[0];
+  suite_setup();
   UnityBegin("t-log.c");
   RUN_TEST(testChangePrognameInMysyslog, 10);
   RUN_TEST(testOpenLogfileTest, 11);
Index: contrib/ntp/sntp/utilities.c
===================================================================
--- contrib/ntp/sntp/utilities.c	(revision 330566)
+++ contrib/ntp/sntp/utilities.c	(revision 330631)
@@ -23,7 +23,7 @@
 		if (a > 0 && a % 8 == 0)
 			fprintf(output, "\n");
 
-		fprintf(output, "%d: %x \t", a, pkt[a]);
+		fprintf(output, "%3d: %02x  ", a, pkt[a]);
 	}
 
 	fprintf(output, "\n");
